﻿--[[Class CArray Definition]]--
function CreateCArray()
	--[[Prepare to create array]]--
	local objCArray = {}
	objCArray.m_objArray = {}	--array
	objCArray.m_nItemCount = 0	--item count of the array
	
	--[[Member function AddItem]]--
	objCArray.AddItem = function(self,objItem)
		self.m_objArray[self.m_nItemCount] = objItem
		self.m_nItemCount = self.m_nItemCount + 1
	end
	
	--[[Member function RemoveItem]]--
	objCArray.RemoveItem = function(self,nIndex)
		--[[Make sure the index value is valid]]--
		if nIndex < 0 or nIndex >= self.m_nItemCount then
			print("Call of |cffff0000CArray::RemoveItem|r failed. Index must be a number fulfilling |cff99d9ff0|r<= index <|cff99d9ff"..(self.m_nItemCount).."|r")
			return false , nil
		end
		--[[prepare to remove it]]--
		local objRemoved = self.m_objArray[nIndex] --assign the removed value to someone
		self.m_objArray[nIndex] = nil --delete item from array
		
		--[[if we want to remove the last item, we have finished our work]]--
		if nIndex == self.m_nItemCount - 1 then
			self.m_nItemCount = self.m_nItemCount - 1 --decrease the item count
			return true , objRemoved
		end
		--[[otherwise, prepare to move items]]--
		local i;
		for i = nIndex, (self.m_nItemCount - 1) do -- from index to the last one
			self.m_objArray[i] = self.m_objArray[i + 1]
		end
		self.m_nItemCount = self.m_nItemCount - 1 --decrease the item count
		return true , objRemoved
	end
	
	--[[Member function GetItem]]--
	objCArray.GetItem = function(self,nIndex)
		--[[Make sure the index value is valid]]--
		if nIndex < 0 or nIndex >= self.m_nItemCount then
			print("Call of |cffff0000CArray::GetItem|r failed. Index must be a number fulfilling |cff99d9ff0|r<= index <|cff99d9ff"..(self.m_nItemCount).."|r")
			return nil
		end
		return self.m_objArray[nIndex]
	end
	
	--[[Member function SetItem]]--
	objCArray.SetItem = function(self,nIndex,objItemNew)
		--[[Make sure the index value is valid]]--
		if nIndex < 0 or nIndex >= self.m_nItemCount then
			print("Call of |cffff0000CArray::SetItem|r failed. Index must be a number fulfilling |cff99d9ff0|r<= index <|cff99d9ff"..(self.m_nItemCount).."|r")
			return false , nil
		end
		--[[prepare to set item value to new one]]--
		local objOld = self.m_objArray[nIndex] --assign the old value to someone
		print(objOld)
		self.m_objArray[nIndex] = nil --delete old value
		self.m_objArray[nIndex] = objItemNew --set value to new one
		return true , objOld
	end
	--[[Member function GetItemCount]]--
	objCArray.GetItemCount = function(self)
		local nItemCount = self.m_nItemCount
		return nItemCount
	end
	--[[object creation complete]]--
	return true, objCArray
end