﻿--[[Class CMenu Definition]]--
--[[Constructor of CMenu]]--
function CreateCMenu(strMenuFrameName)
	local objMenu = {}
	objMenu.m_objMenuFrame  = select(2,Razgriz_CreateFrame("Button",strMenuFrameName))
	if not objMenu.m_objMenuFrame then
		print("Call of |cffff0000CreateCMenu|r failed! since call of Razgriz_CreateFrame failed.")
		return false,nil 
	end
	objMenu.m_objMenuFrame.m_objOwner = objMenu
	objMenu.m_strType = "CMENU"
	objMenu.m_objMenuFrame:Hide()
	objMenu.m_objMenuFrame:SetAlpha(0)
	objMenu.m_objMenuItems = select(2,CreateCArray())
	--[[Member functions]]--
	--[[AddMenuItem]]--
	objMenu.AddMenuItem = function(self,objItem)
		if type(objItem) ~= "table" then
			print("Call of |cffff0000AddMenuItem|r failed! arg1 shall be a CMenuItem object.")
			return false
		elseif objItem.m_strType ~= "CMENUITEM" then
			print("Call of |cffff0000AddMenuItem|r failed! arg1 shall be a CMenuItem object.")
			return false
		end
		objItem.m_objItemFrame:SetParent(self.m_objMenuFrame)
		objItem.m_objItemFrame:SetFrameStrata("DIALOG")
		objItem.m_objItemFrame:SetFrameLevel(self.m_objMenuFrame:GetFrameLevel() + 1)
		self.m_objMenuItems:AddItem(objItem)
		return true
	end
	--[[RemoveItem]]--
	objMenu.RemoveMenuItem = function(self,nIndex)
		local bRet, objItemRemoved = self.m_objMenuItems:RemoveItem(nIndex)
		return bRet,objItemRemoved
	end
	--[[GetMenuItemCount]]--
	objMenu.GetMenuItemCount = function(self)
		return self.m_objMenuItems:GetItemCount()
	end
	--[[IsMouseOver]]--
	objMenu.IsMouseOver = function(self)
		if GetMouseFocus() == objMenu.m_objMenuFrame then
			return true
		elseif self.m_objMenuItems:GetItemCount() > 0 then
			local nIndex
			local nItemCount = self.m_objMenuItems:GetItemCount()
			for nIndex = 0 , nItemCount - 1 do
				local objItem = self.m_objMenuItems:GetItem(nIndex)
				if objItem:IsMouseOver() then
					objItem = nil
					return true
				end
				objItem = nil
			end
		else
			return false
		end
	end
	--[[OnLeave Event]]--
	objMenu.m_objMenuFrame:SetScript("OnEnter",function(self)
		UIFrameFadeRemoveFrame(self)
		self:Show()
		UIFrameFadeIn(self,(1 - self:GetAlpha()) * MediaRazgriz.CommonUIFadeTime,self:GetAlpha(),1)
	end)
	objMenu.m_objMenuFrame:SetScript("OnLeave",function(self)
		if GetMouseFocus() == self:GetParent() then
			return
		end
		--[[Check if item gets focus]]--
		local nIndex
		local nItemCount = self.m_objOwner.m_objMenuItems:GetItemCount()
		for nIndex = 0 , nItemCount - 1 do
			local objItem = self.m_objOwner.m_objMenuItems:GetItem(nIndex)
			if objItem:IsMouseOver() then
				objItem = nil
				return
			end
			objItem = nil
		end
		UIFrameFadeRemoveFrame(self)
		UIFrameFadeOut(self,self:GetAlpha() * MediaRazgriz.CommonUIFadeTime,self:GetAlpha(),0)
		self.fadeInfo.finishedFunc = function()
			self:Hide()
		end
	end)
	return true, objMenu
end