--[[Class CMenuBar Definition]]--
--[[Constructor of CMenuBar]]--
function CreateCMenuBar(strBarName,strIcon,nIconSize,objMenuText,nBarWidth,bAlwaysShowText)
	--[[Check arguments]]--
	if strIcon and type(strIcon) ~= "string" then 
		print("Call of |cffff0000CreateCMenuBar|r failed! arg2 shall be string value which contains path of icon file.")
		return false, nil 
	end
	if not nIconSize then 
		print("Call of |cffff0000CreateCMenuBar|r failed! arg3 shall not be nil.")
		return false, nil 
	elseif type(nIconSize) ~= "number" then
		print("Call of |cffff0000CreateCMenuBar|r failed! arg3 shall not a number.")
		return false, nil 
	elseif nIconSize<=0 then
		print("Call of |cffff0000CreateCMenuBar|r failed! arg3 shall be bigger then zero.")
		return false, nil 
	end
	if objMenuText and type(objMenuText) ~= "string" then
		print("Call of |cffff0000CreateCMenuBar|r failed! arg4 shall be a string value.")
		return false, nil 
	end
	if not nBarWidth then 
		print("Call of |cffff0000CreateCMenuBar|r failed! arg5 shall not be nil.")
		return false, nil 
	elseif type(nBarWidth) ~= "number" then
		print("Call of |cffff0000CreateCMenuBar|r failed! arg5 shall not a number.")
		return false, nil 
	elseif nBarWidth<=0 then
		print("Call of |cffff0000CreateCMenuBar|r failed! arg5 shall be bigger then zero.")
		return false, nil 
	end
	--[[Prepare to create object]]--
	local objMenuBar = {}
	objMenuBar.m_strType = "CMENUBAR"
	--[[Create bar frame]]--
	objMenuBar.m_objMenubarFrame = select(2,Razgriz_CreateFrame("Button",strBarName))
	if not objMenuBar.m_objMenubarFrame then 
		print("Call of |cffff0000CreateCMenuBar|r failed! since call of Razgriz_CreateFrame failed.")
		return false,nil 
	end
	objMenuBar.m_objMenubarFrame.m_objOwner = objMenuBar --set the owner object
	--[[Set menu bar size]]--
	objMenuBar.m_objMenubarFrame:SetHeight(nIconSize)
	if not bAlwaysShowText then 
		objMenuBar.m_objMenubarFrame:SetWidth(nIconSize)
	else 
		objMenuBar.m_objMenubarFrame:SetWidth(nBarWidth)
	end
	objMenuBar.m_bAlwaysShowText = bAlwaysShowText
	
	--[[Create fontstring for menu bar text]]--
	objMenuBar.m_objMenuBarText = objMenuBar.m_objMenubarFrame:CreateFontString((strBarName or "CMenuBar").."Text","OVERLAY","GameFontNormal")
	objMenuBar.m_objMenuBarText:SetText(objMenuText)
	--[[Create icon texture for menu bar icon]]--
	objMenuBar.m_objIcon = objMenuBar.m_objMenubarFrame:CreateTexture((strBarName or "CMenuBar").."Icon","OVERLAY")
	objMenuBar.m_objIcon:SetWidth(nIconSize)
	objMenuBar.m_objIcon:SetHeight(nIconSize)
	objMenuBar.m_objIcon:SetTexture(strIcon)
	--[[Member functions]]--
	--[[GetMenuBarText]]--
	objMenuBar.GetMenuBarText = function(self)
		return self.m_objMenuBarText
	end
	--[[GetIcon]]--
	objMenuBar.GetIcon = function(self)
		return self.m_objIcon
	end
	--[[AttachMenu]]--
	objMenuBar.AttachMenu = function(self,objMenu)
		--[[Check arguments]]--
		if objMenu and type(objMenu) ~= "table" then
			print("Call of |cffff0000AttachMenu|r failed! arg1 shall be a CMenu object.")
			return false,nil
		elseif objMenu then
			if not objMenu.m_strType then
				print("Call of |cffff0000AttachMenu|r failed! arg1 shall be a CMenu object.")
				return false,nil
			elseif objMenu.m_strType ~= "CMENU" then
				print("Call of |cffff0000AttachMenu|r failed! arg1 shall be a CMenu object.")
				return false,nil
			end
		end
		local objMenuOld = self.m_objMenu
		self.m_objMenu = nil
		self.m_objMenu = objMenu
		self.m_objMenu.m_objMenuFrame:SetParent(self.m_objMenubarFrame) --set menu parent to bar
		self.m_objMenu.m_objMenuFrame:SetFrameStrata("DIALOG")
		self.m_objMenu.m_objMenuFrame:SetFrameLevel(self.m_objMenubarFrame:GetFrameLevel() + 1)
		return true,objMenuOld
	end
	--[[script OnEnter]]--
	objMenuBar.m_objMenubarFrame:SetScript("OnEnter",function(self)
		if self.m_objOwner.m_objMenu then
			UIFrameFadeRemoveFrame(self.m_objOwner.m_objMenu.m_objMenuFrame)
			self.m_objOwner.m_objMenu.m_objMenuFrame:Show()
			UIFrameFadeIn(self.m_objOwner.m_objMenu.m_objMenuFrame,(1 - self.m_objOwner.m_objMenu.m_objMenuFrame:GetAlpha()) * MediaRazgriz.CommonUIFadeTime,self.m_objOwner.m_objMenu.m_objMenuFrame:GetAlpha(),1)
		end
	end)
	objMenuBar.m_objMenubarFrame:SetScript("OnLeave",function(self)
		if not self.m_objOwner.m_objMenu then return end
		if self.m_objOwner.m_objMenu:IsMouseOver() then
			return
		else
			UIFrameFadeRemoveFrame(self.m_objOwner.m_objMenu.m_objMenuFrame)
			UIFrameFadeOut(self.m_objOwner.m_objMenu.m_objMenuFrame,self.m_objOwner.m_objMenu.m_objMenuFrame:GetAlpha() * MediaRazgriz.CommonUIFadeTime,self.m_objOwner.m_objMenu.m_objMenuFrame:GetAlpha(),0)
			self.m_objOwner.m_objMenu.m_objMenuFrame.fadeInfo.finishedFunc = function()
				self.m_objOwner.m_objMenu.m_objMenuFrame:Hide() --hide frame after fade out
			end
		end
	end)
	return true, objMenuBar
end