﻿--[[Class CMenuContainer Definition]]--
--[[Constructor of CMenuContainer]]--
function CreateCMenuContainer(strContainName,objParent)
	--[[Prepare to create the container object]]--
	local objCMenuContainer = {} --object to create
	objCMenuContainer.m_strType = "CMENUCONTAINER"
	--[[Create Container frame]]--
	objCMenuContainer.m_objContainerFrame = select(2,Razgriz_CreateFrame("Frame",strContainName,objParent))
	if not objCMenuContainer.m_objContainerFrame then
		print("Call of |cffff0000CreateCMenuContainer|r failed! since call of Razgriz_CreateFrame failed.")
		return false,nil 
	end
	objCMenuContainer.m_objContainerFrame:SetFrameStrata("DIALOG")
	objCMenuContainer.m_objContainerFrame:SetFrameLevel(0)
	objCMenuContainer.m_objContainerFrame:EnableMouse(true)
	--[[Create menu bar array]]--
	objCMenuContainer.m_objMenuBars = select(2,CreateCArray())
	
	--[[Member function implement]]--
	
	--[[DockMenuBar]]--
	objCMenuContainer.DockMenuBar = function(self,objBar)
		if type(objBar) ~= "table" then 
			print("Call of |cffff0000DockMenuBar|r failed! arg1 shall be a CMenuBar object.")
			return false 
		end
		if not objBar.m_strType then
			print("Call of |cffff0000DockMenuBar|r failed! arg1 shall be a CMenuBar object.")
			return false 
		end
		if objBar.m_strType ~= "CMENUBAR" then 
			print("Call of |cffff0000DockMenuBar|r failed! arg1 shall be a CMenuBar object.")
			return false 
		end
		self.m_objMenuBars:AddItem(objBar) --Add menu bar into array
		objBar.m_objMenubarFrame:SetParent(self.m_objContainerFrame) --Set the bar parent to container
		objBar.m_objMenubarFrame:SetFrameStrata("DIALOG") --Set the bar frame strata to dialog
		objBar.m_objMenubarFrame:SetFrameLevel(self.m_objContainerFrame:GetFrameLevel() + 1) --increase bar frame level
		return true
	end
	
	--[[UndockMenuBar]]--
	objCMenuContainer.UndockMenuBar = function(self,nIndex)
		local bRet,objRemoved = self.m_objMenuBars:RemoveItem(nIndex) --Remove menu bar from array
		return bRet , objRemoved
	end
	
	return true , objCMenuContainer
end