﻿--[[Class definition of CMenuItem]]--
--[[Constructor]]--
function CreateCMenuItem(strItemName,strIcon,strItemText,strHighlightTexture)
	--[[Check arguments]]--
	if strIcon and type(strIcon) ~= "string" then
		print("Call of |cffff0000CreateMenuItem|r failed! arg2 shall be string value which contains path of icon file.")
		return false, nil
	end
	if strItemText and type(strItemText) ~= "string" then
		print("Call of |cffff0000CreateMenuItem|r failed! arg3 shall be string value.")
		return false, nil
	end
	if strHighlightTexture and type(strHighlightTexture) ~= "string" then
		print("Call of |cffff0000CreateMenuItem|r failed! arg4 shall be string value which contains path of a tga or blg file.")
		return false, nil
	end
	--[[prepare to create the object]]--
	local objMenuItem = {}
	objMenuItem.m_objItemFrame = select(2,Razgriz_CreateFrame("Button",strItemName))
	if not objMenuItem.m_objItemFrame then
		print("Call of |cffff0000CreateMenuItem|r failed! since call of Razgriz_CreateFrame failed.")
		return false,nil
	end
	objMenuItem.m_objItemFrame.m_objOwner = objMenuItem
	objMenuItem.m_strType = "CMENUITEM"
	--[[Create text fontstring]]--
	objMenuItem.m_objItemText = objMenuItem.m_objItemFrame:CreateFontString((strItemName or "CMenuItem").."Text","OVERLAY","GameFontNormal")
	objMenuItem.m_objItemText:SetText(strItemText)
	--[[CreateIcon]]--
	objMenuItem.m_objItemIcon = objMenuItem.m_objItemFrame:CreateTexture((strItemName or "CMenuItem").."Icon","OVERLAY")
	objMenuItem.m_objItemIcon:SetTexture(strIcon)
	--[[CreateHighlight]]--
	objMenuItem.m_objHighlight = objMenuItem.m_objItemFrame:CreateTexture((strItemName or "CMenuItem").."Highlight","BACKGROUND")
	objMenuItem.m_objHighlight:SetTexture(strHighlightTexture)
	objMenuItem.m_objHighlight:Hide()
	objMenuItem.m_objHighlight:SetAllPoints()
	
	--[[Member functions]]--
	--[[IsMouseOver]]--
	objMenuItem.IsMouseOver = function(self)
		return GetMouseFocus() == self.m_objItemFrame
	end
	--[[GetHighlightTexture]]--
	objMenuItem.GetHighlightTexture = function(self)
		return self.m_objHighlight
	end
	--[[GetItemText]]--
	objMenuItem.GetItemText = function(self)
		return self.m_objItemText
	end
	--[[OnEnter]]--
	objMenuItem.m_objItemFrame:SetScript("OnEnter",function(self)
		self.m_objOwner.m_objHighlight:Show()
		UIFrameFadeRemoveFrame(self:GetParent())
		UIFrameFadeOut(self:GetParent(),(1 - self:GetParent():GetAlpha()) * MediaRazgriz.CommonUIFadeTime,self:GetParent():GetAlpha(),1)
	end)
	objMenuItem.m_objItemFrame:SetScript("OnLeave",function(self)
		self.m_objOwner.m_objHighlight:Hide()
		if (self:GetParent().m_objOwner:IsMouseOver() and GetMouseFocus() ~= self) or self:GetParent():GetParent() == GetMouseFocus()  then --mouse is on other item or menu it self
			return
		else
			UIFrameFadeRemoveFrame(self:GetParent())
			UIFrameFadeOut(self:GetParent(),self:GetParent():GetAlpha() * MediaRazgriz.CommonUIFadeTime,self:GetParent():GetAlpha(),0)
			self:GetParent().fadeInfo.finishedFunc = function()
				self:GetParent():Hide()
			end
		end
		--[[]]--
	end)
	return true, objMenuItem
end