﻿--[[Create frame for common usage]]--
function Razgriz_CreateFrame(strFrameType,strName,objParent)
	--[[First check the arguments]]--
	if (strName) then 
		if type(strName) ~= "string" then
			print("Call of |cffff0000Razgriz_CreateFrame|r failed! arg2 shall be string value.")
			return false , nil
		end
	end
	if (objParent) then
		if type(objParent) ~= "table" then
			print("Call of |cffff0000Razgriz_CreateFramee|r failed! arg3 shall be some frame.")
			return false , nil
		end
	else
		objParent = UIParent --If no parent frame specified, use UIParent instead
	end
	--[[Create the frame]]--
	local frame = CreateFrame(strFrameType,strName,objParent)
	frame:SetBackdrop({
		bgFile = MediaRazgriz.Background.CommonFrameBackground,
		edgeFile = MediaRazgriz.Borders.CommonFrameBorder,
		edgeSize = 1.1,
		insets = {left = 0, right = 0, top = 0, bottom = 0}
	})
	frame:SetBackdropColor(MediaRazgriz.FrameBackdropColor[1],MediaRazgriz.FrameBackdropColor[2],MediaRazgriz.FrameBackdropColor[3],MediaRazgriz.FrameAlpha)
	frame:SetBackdropBorderColor(MediaRazgriz.FrameBorderColor[1],MediaRazgriz.FrameBorderColor[2],MediaRazgriz.FrameBorderColor[3],MediaRazgriz.BorderAlpha)
	
	return true, frame
	
end

--[[Calculate total frame count need for animation within specific time]]--
function Razgriz_CalculateFrameCount(fAnimationTime)
	if not fAnimationTime then
		print("Call of |cffff0000Razgriz_CalculateFrameCount|r failed! arg1 shall not be nil.")
		return 0.0
	elseif type(fAnimationTime) ~="number" then
		print("Call of |cffff0000Razgriz_CalculateFrameCount|r failed! arg1 shall not be nil.")
		return 0.0
	end
	return max(GetFramerate(),60) * fAnimationTime
end
--[[Function to abbreviate time]]--
function Razgriz_TimeAbbr(Time)
    local t = Time
    local d = 3600 * 24
    local h = 3600
    local m = 60
    if t > d then
        return string.format("%dd",t/d)
    elseif t > h then
        return string.format("%dh",t/h)
    elseif t > m then
        return string.format("%dm",t/m)
    elseif t > 5 then
        return string.format("%d",t)
    else
        return string.format("%.1f",t)
    end
end
--[[functions to abbreviate number]]--
function Razgriz_NumberAbbr(number)
    local n = number
    local g = 1000*1000*1000
    local m = 1000*1000
    local k = 1000
    if(n >= g) then
        n = n / g
        return string.format("%.1fg",n)
    elseif n>=m then
        n = n / m
        return string.format("%.1fm",n)
    elseif n>=k then
        n = n / k
        return string.format("%.1fk",n)
    else
        return string.format("%d",n)
    end
end

