﻿--[[VERSION 1.08 ULTIMATE]]--
if select(2,UnitClass("player")) ~= "PALADIN" then return end -- YOU ARE NOT PALADIN. YOU DON'T NEED THIS ADDON!!!!!

--[[配置区域]]--
--[[无圣能且在戰鬥外的時候隱藏，如果你没有战斗，但是還有聖能，那麼就不隱藏。]]--
--[[Hide this UI when you have no HP and out of combat]]--
--[[
bHideWhenNoHPAndNotInCombat		當無戰鬥，且沒有聖能時隱藏
fFadeTime						進入戰鬥，或者獲得聖能後，淡入淡出的時間
]]--

--[[
bHideWhenNoHPAndNotInCombat 	Set to true if you want to hide this ui when you have no HP or not in comabt
fFadeTime						ui fade in / out time 
]]--
local bHideWhenNoHPAndNotInCombat = true
local fFadeTime = 0.5
--[[Configuration section]]--
--[[双翼：
nWingWidth：					双翼的宽度
nWingHeight：					双翼的高度，推荐与宽度一致，因为本身双翼材质是1：1的图片
nOffsetX：						双翼材质距离屏幕中心的X偏移量
nOffSetY：						双翼材质距离屏幕中心的Y偏移量
fWingAnimationTime：			当获得第一道和第二道圣能时，双翼材质填充完成所需要的时间。推荐为一个短的时间较好。
fWingAlpha						雙翼材質的不透明度
objWingTextureColorNotFull:		当圣能不满时，填充材质的颜色和不透明度
objWingTextureColorFull:		当圣能全满时，填充材质的颜色和不透明度
fFullPoweredWingFadeOutTime：	当圣能从3道因脱战而变成两道时，全满材质的淡出时间
fGlowLiteAnimationTime：		当获得圣能或者失去圣能时，会有一个微光边框淡进/淡出，这是淡进/淡出动画的时间。
fGlowBorderMaxAlpha：			当圣能全满时，闪烁边框的最大不透明度
fGlowAnimationTime：			当圣能全满时，闪烁边框完成一次闪烁所需要的时间。推荐为1<->1.5秒
objGlowColor：					闪烁边框的颜色和不透明度
nGlowLineWidth：				当圣能全满时，会有一个发光的线从双翼一端走到另一端，这是那条线段的宽度
fGlowLineAnimationTime：		这是发光线段完成从一端走到另一端所需要的时间，推荐与fWingAnimationTime一致，这样会有极佳的视觉效果
objLineColor：					发光线段的颜色
]]--
--[[Wings:
nWingWidth：					Width of a wing
nWingHeight：					Height of a wing. same value as nWingWidth is recommended since wing texture is 1:1
nOffsetX：						x offset of wing from center of the screen.
nOffSetY：						y offset from center of screen.
fWingAnimationTime：			This is the total time of texture filling animation. when first and second HP is gained a texture fills itself from one side to another.
fWingAlpha						alpha value of wing
objWingTextureColorNotFull:		color and alpha of filling texture when the first and second HP is gained.
objWingTextureColorFull:		color and alpha of filling texture when 3 of HP is gained
fFullPoweredWingFadeOutTime：	time of fading out animation of full HP texture when 3rd HP is lost since you leave combat and be idle for a long time
fGlowLiteAnimationTime：		when gaining or losing HP, a litely glowing border will be faded in or out. This is the fade in / out time of the border
fGlowBorderMaxAlpha：			max HP gained, a glow border which is not the above one will start flashing. This is the max alpha value of this glow border
fGlowAnimationTime：			flash loop time。value between 1<->1.5 is recommended
objGlowColor：					color of the glow border
nGlowLineWidth：				max HP gained，a glow line will move from one side to another side of the wing. this is width of the line
fGlowLineAnimationTime：		this is the total time it consumes to finish moving. For best visual effect, value same as fWingAnimationTime is recommended
objLineColor：					color of the glow line
]]--
local nWingWidth = 115
local nWingHeight = nWingWidth
local nOffsetX = 10
local nOffSetY = -120
local fWingAnimationTime = 0.225
local fWingAlpha = 1
local objWingTextureColorNotFull = {r=240 / 255,g=240 / 255,b=240 / 255,a=1}
local objWingTextureColorFull = {r=246 / 255,g=204 / 255,b=22 / 255,a=1}
local objWingTextureColorFullCrimson = {r=165 / 255,g=0 / 255,b=24 / 255,a=1}
local fFullPoweredWingFadeOutTime = 1
local fGlowLiteAnimationTime = 0.5

local fGlowBorderMaxAlpha = 1
local fGlowAnimationTime = 1
local objGlowColor = {r=255 / 255,g=255 / 255,b=140 / 255}


local nGlowLineWidth = 15
local fGlowLineAnimationTime = fWingAnimationTime
local objLineColor = {r=255/255,g=250/255,b=240/255}



--[[剑
nSwordWidth						我还需要解释吗？
nSwordHeight					我觉得这个也不需要解释，推荐为4倍的宽度因为图片本身就是1：4
fSwordAlpha						不喜欢这把剑的可以把这里设置为0，这样剑就隐藏了
objSwordVeilColor				剑的蒙板颜色
nOffsetYSword					剑的Y偏移量
]]--
--[[Sword
nSwordWidth						You shall know it...
nSwordHeight					The w/h ratio is 1:4. so 4 * nSwordWidth is recommended
fSwordAlpha						alpha value of the sword. those who dislike this sword can simply set this to 0 to hide the sword
objSwordVeilColor				veil alpha and color of the sword
nOffsetYSword					y offset of the sword
]]--

--[[剑材质的填充时间与fWingAnimationTime是一致的]]--
--[[filling time of the sword uses fWingAnimationTime parameter]]--
local nSwordWidth = 35*0.8
local nSwordHeight = nSwordWidth * 4
local fSwordAlpha = 1
local objSwordVeilColor = {r=255 / 255,g=255 / 255,b=255 / 255,a=1}
local nOffsetYSword = -70



--[[Create wing frame]]--
local function CreateWing(strBG,strBorder,strHasPower,strGlowBorder,strGlowLite,strAnchor,nOffsetX,nOffsetY)
	--[[Create wing frame]]--
	local objFrameBG = CreateFrame("Frame",nil,UIParent)
	objFrameBG:SetFrameStrata("DIALOG")
	objFrameBG:SetFrameLevel(1)
	objFrameBG:SetWidth(nWingWidth)
	objFrameBG:SetHeight(nWingHeight)
	objFrameBG:SetPoint(strAnchor,UIParent,"CENTER",nOffsetX,nOffsetY)
	objFrameBG:SetAlpha(fWingAlpha)
	--[[Create wing background texture]]--
	objFrameBG.m_objWingBGTexture = objFrameBG:CreateTexture(nil,"BACKGROUND")
	objFrameBG.m_objWingBGTexture:SetTexture(strBG)
	objFrameBG.m_objWingBGTexture:SetVertexColor(59 / 255, 59 / 255, 59 / 255, MediaRazgriz.BorderAlpha)
	objFrameBG.m_objWingBGTexture:SetAllPoints()
	--[[Create wingBorder texture]]--
	objFrameBG.m_objWingBorderTexture = objFrameBG:CreateTexture(nil,"OVERLAY")
	objFrameBG.m_objWingBorderTexture:SetTexture(strBorder)
	objFrameBG.m_objWingBorderTexture:SetVertexColor(0,0,0,1)
	objFrameBG.m_objWingBorderTexture:SetAllPoints()
	--[[Create power texture]]--
	objFrameBG.m_objWingPowerTexture = objFrameBG:CreateTexture(nil,"ARTWORK")
	objFrameBG.m_objWingPowerTexture:SetWidth(1)
	objFrameBG.m_objWingPowerTexture:SetHeight(nWingHeight)
	objFrameBG.m_objWingPowerTexture:SetTexture(strHasPower)
	objFrameBG.m_objWingPowerTexture:SetVertexColor(objWingTextureColorNotFull.r,objWingTextureColorNotFull.g,objWingTextureColorNotFull.b,objWingTextureColorNotFull.a)
	
	--[[Create full power texture]]--
	objFrameBG.m_objPowerFullFrame = CreateFrame("Frame",nil,objFrameBG)
	objFrameBG.m_objPowerFullFrame:SetAllPoints()
	objFrameBG.m_objPowerFullFrame:SetFrameLevel(objFrameBG:GetFrameLevel())
	objFrameBG.m_objPowerFullFrame.m_objWingPowerTexture = objFrameBG.m_objPowerFullFrame:CreateTexture(nil,"OVERLAY")
	objFrameBG.m_objPowerFullFrame.m_objWingPowerTexture:SetWidth(1)
	objFrameBG.m_objPowerFullFrame.m_objWingPowerTexture:SetHeight(nWingHeight)
	objFrameBG.m_objPowerFullFrame.m_objWingPowerTexture:SetTexture(strHasPower)
	objFrameBG.m_objPowerFullFrame.m_objWingPowerTexture:SetVertexColor(objWingTextureColorFull.r,objWingTextureColorFull.g,objWingTextureColorFull.b,objWingTextureColorFull.a)
	
	--[[Create glow texture]]--
	objFrameBG.m_objWingGlowTexture = objFrameBG:CreateTexture(nil,"BORDER")
	objFrameBG.m_objWingGlowTexture:SetAllPoints()
	objFrameBG.m_objWingGlowTexture:SetTexture(strGlowBorder)
	objFrameBG.m_objWingGlowTexture:SetAlpha(0)
	objFrameBG.m_objWingGlowTexture:SetVertexColor(objGlowColor.r,objGlowColor.g,objGlowColor.b)
	
	--[[Create glow lite frame]]--
	objFrameBG.m_objLiteFrame = CreateFrame("Frame",nil,objFrameBG)
	objFrameBG.m_objLiteFrame:SetFrameLevel(max(objFrameBG:GetFrameLevel() - 1,0))
	objFrameBG.m_objLiteFrame:SetAllPoints()
	objFrameBG.m_objLiteFrame.m_objTextureLite = objFrameBG.m_objLiteFrame:CreateTexture(nil,"BACKGROUND")
	objFrameBG.m_objLiteFrame.m_objTextureLite:SetAllPoints()
	objFrameBG.m_objLiteFrame.m_objTextureLite:SetTexture(strGlowLite)
	objFrameBG.m_objLiteFrame:SetAlpha(0)
	
	return objFrameBG
end
local objWingLeft = CreateWing(MediaRazgriz.Textures.LeftWingBackground,MediaRazgriz.Borders.LeftWingBorder,MediaRazgriz.Textures.LeftWingPower,MediaRazgriz.Borders.LeftWingGlowBorder,MediaRazgriz.Borders.LeftWingGlowBorderLite,"RIGHT",-1 * nOffsetX,nOffSetY)
local objWingRight = CreateWing(MediaRazgriz.Textures.RightWingBackground,MediaRazgriz.Borders.RightWingBorder,MediaRazgriz.Textures.RightWingPower,MediaRazgriz.Borders.RightWingGlowBorder,MediaRazgriz.Borders.RightWingGlowBorderLite,"LEFT",nOffsetX,nOffSetY)
--[[Wing animation function]]--
function WingAnimation(objFrame,strDirection)
	if objFrame.m_bIsFadingOut then -- only full powered wing has m_bIsFadingOut member. So, it is time to stop fading and show full powered wing
		UIFrameFadeRemoveFrame(objFrame) --remove fading
		HideFullPoweredWing(objFrame,true) --immediately hide full powered wing
		objFrame.m_bIsFadingOut = false
	end
	if objFrame:GetWidth() == objFrame.m_objWingPowerTexture:GetWidth() or objFrame:GetScript("OnUpdate") then
		return --animation has already been over
	end
	if objFrame.m_objLiteFrame then
		UIFrameFadeRemoveFrame(objFrame.m_objLiteFrame)
		UIFrameFadeIn(objFrame.m_objLiteFrame,(1-objFrame.m_objLiteFrame:GetAlpha()) * fGlowLiteAnimationTime,objFrame.m_objLiteFrame:GetAlpha(),1)
	end
	
	objFrame:SetAlpha(1)
	objFrame.m_objWingPowerTexture:ClearAllPoints()
	objFrame.m_strDirection = strDirection
	if strDirection == "LEFT" then
		objFrame.m_objWingPowerTexture:SetPoint("RIGHT")
	else
		objFrame.m_objWingPowerTexture:SetPoint("LEFT")
	end
	--[[Prepare to start animation]]--
	objFrame.m_objWingPowerTexture:SetWidth(1) --MUST NOT BE ZERO or WIDTH WILL BE SETTED TO TEXTURE METRIC
	objFrame.m_objWingPowerTexture:SetHeight(nWingHeight)
	objFrame:SetScript("OnUpdate",function(self)
		local fStep = self:GetWidth() / Razgriz_CalculateFrameCount(fWingAnimationTime)
		if self.m_objWingPowerTexture:GetWidth() < self:GetWidth() then
			self.m_objWingPowerTexture:SetWidth(min(self.m_objWingPowerTexture:GetWidth() + fStep, self:GetWidth()))
			if self.m_strDirection == "LEFT" then
				self.m_objWingPowerTexture:SetTexCoord(1 - (self.m_objWingPowerTexture:GetWidth() / self:GetWidth()),1,0,1)
			else
				self.m_objWingPowerTexture:SetTexCoord(0, self.m_objWingPowerTexture:GetWidth() / self:GetWidth(),0,1)
			end
		else
			self:SetScript("OnUpdate",nil)
		end
	end)
end

--[[Hide full powered wing function]]--
function HideFullPoweredWing(objFrame,bIsImmediate)
	if bIsImmediate then
		objFrame:SetScript("OnUpdate",nil)
		objFrame.m_objWingPowerTexture:SetWidth(1)
		objFrame.m_objWingPowerTexture:SetTexCoord(0,0,0,1)
		return
	end
	UIFrameFadeRemoveFrame(objFrame)
	UIFrameFadeOut(objFrame,objFrame:GetAlpha() * fFullPoweredWingFadeOutTime,objFrame:GetAlpha(),0)
	objFrame.m_bIsFadingOut = true
	objFrame.fadeInfo.finishedArg1 = objFrame
	objFrame.fadeInfo.finishedFunc = function(self)
		self:SetScript("OnUpdate",nil)
		self.m_objWingPowerTexture:SetWidth(1)
		self.m_objWingPowerTexture:SetTexCoord(0,0,0,1)
	end
end
--[[Hide wing function]]--
function HideWing(objFrame)
	objFrame:SetScript("OnUpdate",nil)
	objFrame.m_objWingPowerTexture:SetWidth(1)
	objFrame.m_objWingPowerTexture:SetTexCoord(0,0,0,1)
	
	HideFullPoweredWing(objFrame.m_objPowerFullFrame,true)
	
	if objFrame.m_objLiteFrame then
		UIFrameFadeRemoveFrame(objFrame.m_objLiteFrame)
		UIFrameFadeOut(objFrame.m_objLiteFrame,objFrame.m_objLiteFrame:GetAlpha() * fGlowLiteAnimationTime,objFrame.m_objLiteFrame:GetAlpha(),0)
	end
end
--[[Left wing animation]]--
objWingLeft:RegisterEvent("UNIT_POWER")
objWingLeft:RegisterEvent("PLAYER_ENTERING_WORLD") --REGISTER THIS EVENT FOR HP WILL BE CLEARED WHEN ENTERING ARENA
objWingLeft:RegisterEvent("UNIT_DISPLAYPOWER")
objWingLeft:SetScript("OnEvent",function(self,strEvent,strUnit,strPowerType)
	if strEvent == "UNIT_POWER" and strUnit == "player" and strPowerType == "HOLY_POWER" then
		local nPowerNum = UnitPower("player",SPELL_POWER_HOLY_POWER )
		if nPowerNum >= 1 then --Show wing
			WingAnimation(self,"LEFT")
		else
			HideWing(self)
		end
	else
		local nPowerNum = UnitPower("player",SPELL_POWER_HOLY_POWER )
		if nPowerNum >= 1 then --Show wing
			WingAnimation(self,"LEFT")
		else
			HideWing(self)
		end
	end
end)
--[[Right wing animation]]--
objWingRight:RegisterEvent("UNIT_POWER")
objWingRight:RegisterEvent("PLAYER_ENTERING_WORLD") --REGISTER THIS EVENT FOR HP WILL BE CLEARED WHEN ENTERING ARENA
objWingRight:RegisterEvent("UNIT_DISPLAYPOWER")
objWingRight:SetScript("OnEvent",function(self,strEvent,strUnit,strPowerType)
	if strEvent == "UNIT_POWER" and strUnit == "player" and strPowerType == "HOLY_POWER" then
		local nPowerNum = UnitPower("player",SPELL_POWER_HOLY_POWER )
		if nPowerNum >= 2 then --Show wing
			WingAnimation(self,"RIGHT")
		else
			HideWing(self)
		end
	else
		local nPowerNum = UnitPower("player",SPELL_POWER_HOLY_POWER )
		if nPowerNum >= 2 then --Show wing
			WingAnimation(self,"RIGHT")
		else
			HideWing(self)
		end
	end
end)
--[[Create the sword]]--
local objFrameBGSword = CreateFrame("Frame",nil,UIParent)
objFrameBGSword:SetFrameStrata("DIALOG")
objFrameBGSword:SetWidth(nSwordWidth)
objFrameBGSword:SetHeight(nSwordHeight)
objFrameBGSword:SetPoint("TOP",UIParent,"CENTER",0,nOffsetYSword)
objFrameBGSword:SetAlpha(fSwordAlpha)
--[[Create sword background]]--
objFrameBGSword.m_objSwordBGTexture = objFrameBGSword:CreateTexture(nil,"BACKGROUND")
objFrameBGSword.m_objSwordBGTexture:SetTexture(MediaRazgriz.Textures.SwordPower)
objFrameBGSword.m_objSwordBGTexture:SetVertexColor(.4,.4,.4,1)
objFrameBGSword.m_objSwordBGTexture:SetDesaturated(true)
objFrameBGSword.m_objSwordBGTexture:SetAllPoints()

--[[Create border texture]]--
objFrameBGSword.m_objSwordBorderTexture = objFrameBGSword:CreateTexture(nil,"OVERLAY")
objFrameBGSword.m_objSwordBorderTexture:SetTexture(MediaRazgriz.Borders.SwordBorder)
objFrameBGSword.m_objSwordBorderTexture:SetVertexColor(0,0,0,1)
objFrameBGSword.m_objSwordBorderTexture:SetAllPoints()
--[[Create power texture]]--
objFrameBGSword.m_objSwordPowerTexture = objFrameBGSword:CreateTexture(nil,"ARTWORK")
objFrameBGSword.m_objSwordPowerTexture:SetWidth(nSwordWidth)
objFrameBGSword.m_objSwordPowerTexture:SetHeight(1)
objFrameBGSword.m_objSwordPowerTexture:SetTexture(MediaRazgriz.Textures.SwordPower)
objFrameBGSword.m_objSwordPowerTexture:SetVertexColor(objSwordVeilColor.r,objSwordVeilColor.g,objSwordVeilColor.b,objSwordVeilColor.a)

function SwordAnimation(objFrame)
	if objFrame:GetHeight() == objFrame.m_objSwordPowerTexture:GetHeight() or objFrame:GetScript("OnUpdate") then
		return --animation has already been over
	end
	--[[Prepate to animate]]--
	objFrame.m_objSwordPowerTexture:ClearAllPoints()
	objFrame.m_objSwordPowerTexture:SetPoint("TOP")
	objFrame.m_objSwordPowerTexture:SetHeight(1)
	objFrame.m_objSwordPowerTexture:SetWidth(nSwordWidth)
	objFrame.m_objSwordPowerTexture:SetTexCoord(0,1,0,0)
	objFrame:SetScript("OnUpdate",function(self)
		local fStep = self:GetHeight() / Razgriz_CalculateFrameCount(fWingAnimationTime)
		if self.m_objSwordPowerTexture:GetHeight() < self:GetHeight() then
			self.m_objSwordPowerTexture:SetHeight(min(self:GetHeight(),self.m_objSwordPowerTexture:GetHeight() + fStep))
			self.m_objSwordPowerTexture:SetTexCoord(0,1,0,self.m_objSwordPowerTexture:GetHeight() / self:GetHeight())
		else
			self:SetScript("OnUpdate",nil)
		end
	end)
end

function HideSword(objFrame)
	objFrame:SetScript("OnUpdate",nil)
	objFrame.m_objSwordPowerTexture:SetHeight(1)
	objFrame.m_objSwordPowerTexture:SetTexCoord(0,1,0,0)
end
objFrameBGSword:RegisterEvent("UNIT_POWER")
objFrameBGSword:RegisterEvent("PLAYER_ENTERING_WORLD") --REGISTER THIS EVENT FOR HP WILL BE CLEARED WHEN ENTERING ARENA
objFrameBGSword:RegisterEvent("UNIT_DISPLAYPOWER")

--[[Glow animation]]--
local objFrameForGlow = CreateFrame("Frame")

function FadeOutAllBorders()
	objFrameForGlow:SetScript("OnUpdate",function(self)
		local fStep = fGlowBorderMaxAlpha / Razgriz_CalculateFrameCount(fGlowAnimationTime)
		if objWingLeft.m_objWingGlowTexture:GetAlpha() > 0 then
			objWingLeft.m_objWingGlowTexture:SetAlpha(max(objWingLeft.m_objWingGlowTexture:GetAlpha() - fStep,0))
			objWingRight.m_objWingGlowTexture:SetAlpha(max(objWingRight.m_objWingGlowTexture:GetAlpha() - fStep,0))
		else
			FadeInAllBorders()
		end
	end)
end
function FadeInAllBorders()
	objFrameForGlow:SetScript("OnUpdate",function(self)
		local fStep = fGlowBorderMaxAlpha / Razgriz_CalculateFrameCount(fGlowAnimationTime)
		if objWingLeft.m_objWingGlowTexture:GetAlpha() < fGlowBorderMaxAlpha then
			objWingLeft.m_objWingGlowTexture:SetAlpha(min(objWingLeft.m_objWingGlowTexture:GetAlpha() + fStep,fGlowBorderMaxAlpha))
			objWingRight.m_objWingGlowTexture:SetAlpha(min(objWingRight.m_objWingGlowTexture:GetAlpha() + fStep,fGlowBorderMaxAlpha))
		else
			FadeOutAllBorders()
		end
	end)
end
function EndGlow()
	objFrameForGlow:SetScript("OnUpdate",nil)
	objWingLeft.m_objWingGlowTexture:SetAlpha(0)
	objWingRight.m_objWingGlowTexture:SetAlpha(0)
end

--[[Creat glow line for 3 holy power]]--
local objFrameGlowLine = CreateFrame("Frame",nil,UIParent)
objFrameGlowLine:SetFrameStrata("DIALOG")
--[[Left glow line texture]]--
objFrameGlowLine.m_objLeftLine = objFrameGlowLine:CreateTexture(nil,"BACKGROUND")
objFrameGlowLine.m_objLeftLine:SetTexture(objWingLeft.m_objWingGlowTexture:GetTexture())
objFrameGlowLine.m_objLeftLine:SetHeight(objWingLeft:GetHeight())
objFrameGlowLine.m_objLeftLine:SetWidth(nGlowLineWidth)
objFrameGlowLine.m_objLeftLine:SetVertexColor(objLineColor.r,objLineColor.g,objLineColor.b)
objFrameGlowLine.m_objLeftLine:SetAlpha(0.5)
objFrameGlowLine.m_objLeftLine.m_fOffset = 0
--[[Right glow line texture]]--
objFrameGlowLine.m_objRightLine = objFrameGlowLine:CreateTexture(nil,"BACKGROUND")
objFrameGlowLine.m_objRightLine:SetTexture(objWingRight.m_objWingGlowTexture:GetTexture())
objFrameGlowLine.m_objRightLine:SetHeight(objWingLeft:GetHeight())
objFrameGlowLine.m_objRightLine:SetWidth(nGlowLineWidth)
objFrameGlowLine.m_objRightLine:SetVertexColor(objLineColor.r,objLineColor.g,objLineColor.b)
objFrameGlowLine.m_objRightLine:SetAlpha(0.5)
objFrameGlowLine.m_objRightLine.m_fOffset = 0
--[[Glow line animation function]]--
objFrameGlowLine.StartGlowLine = function(self)
	if self:GetScript("OnUpdate") or self.m_objLeftLine.m_fOffset + self.m_objLeftLine:GetWidth() >= objWingLeft:GetWidth()  then 
		return --animation has already been over
	end
	--[[Prepate glow line]]--
	--[[Left line]]--
	self.m_objLeftLine:ClearAllPoints()
	self.m_objLeftLine:SetPoint("RIGHT",objWingLeft)
	self.m_objLeftLine:SetWidth(nGlowLineWidth)
	self.m_objLeftLine.m_fOffset = 0
	self.m_objLeftLine:Show()
	--[[Right line]]--
	self.m_objRightLine:ClearAllPoints()
	self.m_objRightLine:SetPoint("LEFT",objWingLeft)
	self.m_objRightLine:SetWidth(nGlowLineWidth)
	self.m_objRightLine.m_fOffset = 0
	self.m_objRightLine:Show()
	
	self:SetScript("OnUpdate",function(self)
		local fStep = (objWingLeft:GetWidth() - self.m_objLeftLine:GetWidth())  / Razgriz_CalculateFrameCount(fGlowLineAnimationTime)
		if(self.m_objLeftLine.m_fOffset + self.m_objLeftLine:GetWidth()) < objWingLeft:GetWidth() then
			self.m_objLeftLine.m_fOffset = min(self.m_objLeftLine.m_fOffset + fStep,objWingLeft:GetWidth() - self.m_objLeftLine:GetWidth())
			self.m_objRightLine.m_fOffset = min(self.m_objRightLine.m_fOffset + fStep,objWingRight:GetWidth() - self.m_objRightLine:GetWidth()) --same offset with left
			self.m_objLeftLine:ClearAllPoints()
			self.m_objLeftLine:SetPoint("RIGHT",objWingLeft,-1 * self.m_objLeftLine.m_fOffset,0)
			
			self.m_objRightLine:ClearAllPoints()
			self.m_objRightLine:SetPoint("LEFT",objWingRight,self.m_objRightLine.m_fOffset,0)
			
			self.m_objLeftLine:SetTexCoord((objWingLeft:GetWidth() - (self.m_objLeftLine:GetWidth()+self.m_objLeftLine.m_fOffset)) / objWingLeft:GetWidth(),1-(self.m_objLeftLine.m_fOffset)/objWingLeft:GetWidth(),0,1)
			self.m_objRightLine:SetTexCoord(self.m_objRightLine.m_fOffset / objWingRight:GetWidth(),(self.m_objRightLine.m_fOffset + self.m_objRightLine:GetWidth())/objWingRight:GetWidth(),0,1)
		else
			self.m_objLeftLine:Hide()
			self.m_objRightLine:Hide()
			self:SetScript("OnUpdate",nil)
		end
	end)
end

objFrameGlowLine.StopGlowLine = function(self)
	self:SetScript("OnUpdate",nil)
	self.m_objLeftLine:Hide()
	self.m_objLeftLine.m_fOffset = 0
	self.m_objRightLine:Hide()
	self.m_objRightLine.m_fOffset = 0
end

--[[Sword on event handler]]--
objFrameBGSword:SetScript("OnEvent",function(self,strEvent,strUnit,strPowerType)
	local nPowerNum = UnitPower("player",SPELL_POWER_HOLY_POWER )
	if nPowerNum >= 3 then --Show sowrd and full powered wing
		SwordAnimation(self)
		if not objFrameForGlow:GetScript("OnUpdate") then
			FadeInAllBorders()
		end
		WingAnimation(objWingLeft.m_objPowerFullFrame,"LEFT")
		WingAnimation(objWingRight.m_objPowerFullFrame,"RIGHT")
		objFrameGlowLine:StartGlowLine()
	else
		HideSword(self)
		EndGlow()
		objFrameGlowLine:StopGlowLine()
		HideFullPoweredWing(objWingLeft.m_objPowerFullFrame,false)
		HideFullPoweredWing(objWingRight.m_objPowerFullFrame,false)
	end
	
	if nPowerNum >= 4 then
		objWingLeft.m_objPowerFullFrame.m_objWingPowerTexture:SetVertexColor(objWingTextureColorFullCrimson.r,objWingTextureColorFullCrimson.g,objWingTextureColorFullCrimson.b,objWingTextureColorFullCrimson.a)
	else
		objWingLeft.m_objPowerFullFrame.m_objWingPowerTexture:SetVertexColor(objWingTextureColorFull.r,objWingTextureColorFull.g,objWingTextureColorFull.b,objWingTextureColorFull.a)
	end
	
	if nPowerNum >= 5 then
		objWingRight.m_objPowerFullFrame.m_objWingPowerTexture:SetVertexColor(objWingTextureColorFullCrimson.r,objWingTextureColorFullCrimson.g,objWingTextureColorFullCrimson.b,objWingTextureColorFullCrimson.a)
	else
		objWingRight.m_objPowerFullFrame.m_objWingPowerTexture:SetVertexColor(objWingTextureColorFull.r,objWingTextureColorFull.g,objWingTextureColorFull.b,objWingTextureColorFull.a)
	end
end)

--[[Create ui show/hide handle]]--
local objUIHandler  = CreateFrame("Frame")
objUIHandler.m_bNotInCombat = true
objUIHandler:RegisterEvent("UNIT_POWER")
objUIHandler:RegisterEvent("PLAYER_ENTERING_WORLD") --REGISTER THIS EVENT FOR HP WILL BE CLEARED WHEN ENTERING ARENA
objUIHandler:RegisterEvent("UNIT_DISPLAYPOWER")
objUIHandler:RegisterEvent("PLAYER_REGEN_ENABLED")
objUIHandler:RegisterEvent("PLAYER_REGEN_DISABLED")
objUIHandler:SetScript("OnEvent",function(self,strEvent)
	if not bHideWhenNoHPAndNotInCombat then return end
	if strEvent == "PLAYER_REGEN_ENABLED" then
		self.m_bNotInCombat = true
	elseif strEvent == "PLAYER_REGEN_DISABLED" then
		self.m_bNotInCombat = false
	end
	local nPowerNum = UnitPower("player",SPELL_POWER_HOLY_POWER )
	if nPowerNum <= 0 and self.m_bNotInCombat then
		UIFrameFadeRemoveFrame(objWingLeft)
		UIFrameFadeRemoveFrame(objWingRight)
		UIFrameFadeRemoveFrame(objFrameBGSword)
		UIFrameFadeOut(objWingLeft,objWingLeft:GetAlpha()  / fWingAlpha * fFadeTime,objWingLeft:GetAlpha(),0)
		UIFrameFadeOut(objWingRight,objWingRight:GetAlpha() / fWingAlpha * fFadeTime,objWingRight:GetAlpha(),0)
		UIFrameFadeOut(objFrameBGSword,objFrameBGSword:GetAlpha() / fSwordAlpha * fFadeTime,objFrameBGSword:GetAlpha(),0)
	else
		UIFrameFadeRemoveFrame(objWingLeft)
		UIFrameFadeRemoveFrame(objWingRight)
		UIFrameFadeRemoveFrame(objFrameBGSword)
		UIFrameFadeIn(objWingLeft,(fWingAlpha-objWingLeft:GetAlpha()) / fWingAlpha * fFadeTime,objWingLeft:GetAlpha(),fWingAlpha)
		UIFrameFadeIn(objWingRight,(fWingAlpha-objWingRight:GetAlpha()) / fWingAlpha * fFadeTime,objWingRight:GetAlpha(),fWingAlpha)
		UIFrameFadeIn(objFrameBGSword,(fSwordAlpha-objFrameBGSword:GetAlpha()) / fSwordAlpha * fFadeTime,objFrameBGSword:GetAlpha(),fSwordAlpha)
	end
end)
